package langtest;

import java.util.ArrayList;
import java.util.List;

import com.aliasi.sentences.MedlineSentenceModel;
import com.aliasi.sentences.SentenceModel;
import com.aliasi.tokenizer.IndoEuropeanTokenizerFactory;
import com.aliasi.tokenizer.Tokenizer;
import com.aliasi.tokenizer.TokenizerFactory;

public class SentenceBoundryText {
	static private final String demotxt = "The induction of immediate-early (IE) response genes, such as egr-1, c-fos, and c-jun, occurs rapidly after the activation of T lymphocytes. The process of activation involves calcium mobilization activation of protein kinase C (PKC), and phosphorylation of tyrosine kinases. p21(ras), a guanine nucleotide binding factor, mediates T-cell signal transduction through PKC-dependent and PKC-independent pathways. The involvement of p21(ras) in the regulation of calcium-dependent signals has been suggested through analysis of its role in the activation of NF-AT. We have investigated the inductions of the IE genes in response to calcium signals in Jurkat cells (in the presence of activated p21(ras)) and their correlated consequences.";
	static private final TokenizerFactory txtTokenize = new IndoEuropeanTokenizerFactory();
	static private final SentenceModel sentenceModel = new MedlineSentenceModel(); 
	
	public SentenceBoundryText() {
		
	}

	public ArrayList getSentences() {
		Tokenizer tokenizer = txtTokenize.tokenizer(demotxt.toCharArray(), 0, demotxt.length());
		ArrayList tokenList = new ArrayList();
		ArrayList whiteList = new ArrayList();

		tokenizer.tokenize(tokenList, whiteList);
		
		System.out.println(tokenList.size() + " TOKENS");
		System.out.println(whiteList.size() + " WHITESPACES");

		String[] tokens = new String[tokenList.size()];
		String[] whites = new String[whiteList.size()];
		tokenList.toArray(tokens);
		whiteList.toArray(whites);
		int[] sentenceBoundaries = sentenceModel.boundaryIndices(tokens,whites);

		System.out.println(sentenceBoundaries.length 
				   + " SENTENCE END TOKEN OFFSETS");
			
		if (sentenceBoundaries.length < 1) {
		    System.out.println("No sentence boundaries found.");
		    return null;
		}
		int sentStartTok = 0;
		int sentEndTok = 0;
		ArrayList<String> sentences = new ArrayList<String>();
		for (int i = 0; i < sentenceBoundaries.length; ++i) {
			String sentence = "";
		    sentEndTok = sentenceBoundaries[i];
		    System.out.println("SENTENCE "+(i+1)+": ");
		    for (int j=sentStartTok; j<=sentEndTok; j++) {
		    	sentence += tokens[j]+whites[j+1];
		    }
		    
		    sentStartTok = sentEndTok+1;
		    sentences.add(sentence);
		}
		return sentences;

		
	}

	/*GeniaChunker(TokenizerFactory tf, TokenShapeDecoder decoder) {
		super(tf, decoder);
		// TODO Auto-generated constructor stub
	}*/

}
