package org.ntnu.masteroppg.index;

import java.text.BreakIterator;
/**
 * Implements sentence iterator with javas native BreakIterator
 */
public class NativeSentenceIterator implements SentenceIterator {
	
	private String text;
	public NativeSentenceIterator(String text)  {
		this.text = text;
		
	}
	public void run() {
		BreakIterator boundary = BreakIterator.getSentenceInstance();
		boundary.setText(text);
		int start = boundary.first();
		int end = boundary.next();
		for (; end != BreakIterator.DONE; start = end, end = boundary.next()) {
			BreakIterator wordBoundary = BreakIterator.getWordInstance();
			wordBoundary.setText(text.substring(start, end));
			int tokens = 0;
			int tokenEnd;
			for (tokenEnd = wordBoundary.next()
					; tokenEnd != BreakIterator.DONE
					; tokenEnd = wordBoundary.next()) {
				tokens++;
			}
			handleNext(text.substring(start, end), start, end, tokens);
		}
	}

	/**
	 * Override this to handle each sentence.
	 */
	public void handleNext(String sentence, int start, int end, int tokens) {
		throw new UnsupportedOperationException();
	}
	

}

