package org.ntnu.masteroppg.index;

import java.io.Serializable;
import java.util.Comparator;

public class Sentence implements Serializable {
	private static final long serialVersionUID = 3701517221403523710L;
	private int position;
	private float weight;
	
	public Sentence(int offset, float weigth) {
		this.position = offset;
		this.weight = weigth;
	}
	public int position() {
		return position;
	}
	public float weight() {
		return weight;
	}
	public static Comparator<Sentence> sortByOffset() {
		return SentenceSorter.instance;
	}
}

/**
 * To sort sentences by offset
 */
class SentenceSorter implements Comparator<Sentence> {
	public int compare(Sentence a, Sentence b) {
		return (a.position() > b.position()) 
			? 1 : ((a.position() == b.position())) 
			? 0 : -1;
	}
	public static SentenceSorter instance = new SentenceSorter();
	
}