package org.ntnu.masteroppg.luceneExt;

import java.io.IOException;
import java.io.Reader;

import org.apache.lucene.analysis.LowerCaseFilter;
import org.apache.lucene.analysis.StopFilter;
import org.apache.lucene.analysis.TokenStream;
import org.apache.lucene.analysis.standard.StandardAnalyzer;
import org.apache.lucene.analysis.standard.StandardFilter;
import org.apache.lucene.analysis.standard.StandardTokenizer;
import org.apache.lucene.analysis.standard.StandardAnalyzer.SavedStreams;

/**
 * Same code as in StandardAnalyzer, using SentenceTokenizer instead.
 * @author dagurval
 *
 */
public class SentenceAnalyzer extends StandardAnalyzer {
	  public TokenStream reusableTokenStream(String fieldName, Reader reader) throws IOException {
		    SavedStreams streams = (SavedStreams) getPreviousTokenStream();
		    if (streams == null) {
		      streams = new SavedStreams();
		      setPreviousTokenStream(streams);
		      streams.tokenStream = new SentenceTokenizer(reader);
		      streams.filteredTokenStream = new StandardFilter(streams.tokenStream);
		      streams.filteredTokenStream = new LowerCaseFilter(streams.filteredTokenStream);
		      streams.filteredTokenStream = new StopFilter(streams.filteredTokenStream, stopSet);
		    } else {
		      streams.tokenStream.reset(reader);
		    }
		    streams.tokenStream.setMaxTokenLength(maxTokenLength);
		    
		    streams.tokenStream.setReplaceInvalidAcronym(replaceInvalidAcronym);

		    return streams.filteredTokenStream;
		  }
}
