package org.ntnu.masteroppg.luceneExt;

import java.io.IOException;

import org.apache.lucene.index.Term;
import org.apache.lucene.search.PhraseQuery;
import org.apache.lucene.search.Searcher;
import org.apache.lucene.search.Weight;
//import org.apache.lucene.search.PhraseQuery.PhraseWeight;
import org.ntnu.masteroppg.index.SentenceIndex;

public class SentencePhraseQuery extends PhraseQuery {
	private static final long serialVersionUID = 9069870890975127748L;
	private SentenceIndex sentIndex;

	public SentencePhraseQuery(SentenceIndex sentIndex) {
		this.sentIndex = sentIndex;
	}
	
	  protected Weight createWeight(Searcher searcher) throws IOException {
		    if (terms.size() == 1) {			  // optimize one-term case
		      Term term = (Term)terms.get(0);
		      SentenceTermQuery termQuery = new SentenceTermQuery(term, sentIndex);
		      termQuery.setBoost(getBoost());
		      return termQuery.createWeight(searcher);
		    }
		    else {
		    	return super.createWeight(searcher);
		    }
		  }
}
