package org.ntnu.masteroppg.luceneExt;

import java.io.IOException;
import java.io.Reader;

import org.apache.log4j.Logger;
import org.apache.lucene.analysis.Token;
import org.apache.lucene.analysis.standard.StandardAnalyzer;
import org.apache.lucene.analysis.standard.StandardTokenizer;
import org.apache.lucene.analysis.standard.StandardTokenizerImpl;

public class SentenceTokenizer extends StandardTokenizer {
	
	private Logger log = Logger.getLogger(this.getClass());
	
	  public SentenceTokenizer(Reader input) {
		  super(input);
		/*    this.input = input;
		    this.scanner = new StandardTokenizerImpl(input);*/
	}


	  
	
	
	public Token next(final Token reusableToken) throws IOException {
	      assert reusableToken != null;
	      int posIncr = 1;

	      while(true) {
		int tokenType = scanner.getNextToken();

		if (tokenType == StandardTokenizerImpl.YYEOF) {
		    return null;
		}

	        if (scanner.yylength() <= maxTokenLength) {
	          reusableToken.clear();
	          reusableToken.setPositionIncrement(posIncr);
	          scanner.getText(reusableToken);
	          final int start = scanner.yychar();
	          final int end = start + reusableToken.termLength();

	          reusableToken.setStartOffset(start);
	          reusableToken.setEndOffset(end);
	          // This 'if' should be removed in the next release. For now, it converts
	          // invalid acronyms to HOST. When removed, only the 'else' part should
	          // remain.
	          if (tokenType == StandardTokenizerImpl.ACRONYM_DEP) {
	            if (false) {
	              reusableToken.setType(StandardTokenizerImpl.TOKEN_TYPES[StandardTokenizerImpl.HOST]);
	              reusableToken.setTermLength(reusableToken.termLength() - 1); // remove extra '.'
	            } else {
	              reusableToken.setType(StandardTokenizerImpl.TOKEN_TYPES[StandardTokenizerImpl.ACRONYM]);
	            }
	          } else {
	            reusableToken.setType(StandardTokenizerImpl.TOKEN_TYPES[tokenType]);
	          }
	          return reusableToken;
	        } else
	          // When we skip a too-long term, we still increment the
	          // position increment
	          posIncr++;
	      }
	    }

}
