package org.ntnu.masteroppg.luceneExt;

import java.io.IOException;
import java.util.Iterator;

import org.apache.lucene.index.CorruptIndexException;
import org.apache.lucene.index.TermPositions;
import org.ntnu.masteroppg.index.Sentence;
import org.ntnu.masteroppg.index.SentenceIndex;

public class SentenceWeights {  

	/**
	 * Finds average sentence boost for given term.
	 */
	public static float avgTermSentenceWeight(SentenceIndex sentenceIndex, TermPositions termPos, int ptr) throws IOException, CorruptIndexException {
		if (termPos == null)
			throw new AssertionError("termPos cannot be null");
		
		Iterator<Sentence> sitr = sentenceIndex.iterator(ptr);
		
		float sentenceWeight = 0;
		Sentence sentence;
		
		if (!sitr.hasNext()) {
			System.err.println("SentenceWeights: " + termPos.doc() + " has no sentences indexed.");
			return 0f;
		}
		sentence = sitr.next();

		
		int termFreq = termPos.freq();
		for (int i = 0; i < termFreq; i++) {
			
			int pos = termPos.nextPosition();
			
			// match it against a sentence in sentence index
			while (sentence.position() < pos) {
				if (!sitr.hasNext()) {
					System.err.println("SentenceWeights: could not match term. "
							+ "doc: " + termPos.doc() + ", pos: " + pos 
							+ " at sentence " + sentence.position());
					//log.fatal("Document contents: " + indexReader.document(termPos.doc()).getField(abstrField).stringValue());
					//System.exit(1);
					break;
				}
				sentence = sitr.next();
			}
				
			//System.err.println("found weight " + sentence.weight());
			sentenceWeight += sentence.weight();
		}

		return sentenceWeight / termFreq;
	}
}
/*
	@Override
	public int doc() {
		//log.debug("doc");
		return termPos.doc();
		//return termDocs.doc();
		//return 1;
	}

	@Override
	public boolean next() throws IOException {
		return termPos.next();	
		//return termDocs.next();
		
	}

	@Override
	public boolean skipTo(int target) throws IOException {
		log.debug("skipTo");
		return termPos.skipTo(target);
		//return false;
	}

}
*/